# Scatter Map
## Introduction
The scatter map is a custom plugin for Superset build using leaflet.js. Leaflet(leaflet.js) is a opensource javascript library for maps that uses OpenStreetMap's API and thus it requires a live internet connection to render the map. The scatter map allows a user to plot scatter points on a world map where the radius of the point could be fixed or changed according to a metric. As the map is zoomed out/in, points are clustered dynamically based on their proximity.

## Creating the plugin
In the scatter map plugin, we render the world map and scatter points for co-ordinates provided. 

### Rendering the Map
To render the map, we first import leaflet.js and other necessary files.
```js
import L from 'leaflet';
import 'leaflet/dist/leaflet.css';
import 'leaflet.markercluster/dist/MarkerCluster.css';
import 'leaflet.markercluster/dist/MarkerCluster.Default.css';
import 'leaflet.markercluster';
```

The `leaflet.css` file defines the map-stylings used in leaflet. The `markercluster` files perform dynamic clustering of the points on the map. A leaflet map instance is created and the image of the world map is added as a `tileLayer` to the map instance.

### Fetching Co-ordinates

The co-ordinates of the scatter points are fetched from the database. The radius of each point is determined based on user's choice from the control panel. By default, the radius is fixed at 10. But the user has a choice to use any metric to determine the radius of each point.

### Setting Map Viewpoint

Once the co-ordinates of the points are fetched, a bounding box is created from the points by finding the min and max values of the longitude and latitude. Then the map viewpoint is fit into this bounding box. 